searchData={"items":[{"type":"module","title":"A11yAudit.Assertions","doc":"ExUnit assertions","ref":"A11yAudit.Assertions.html"},{"type":"function","title":"A11yAudit.Assertions.assert_no_violations/2","doc":"Asserts that the given audit results have no violations.","ref":"A11yAudit.Assertions.html#assert_no_violations/2"},{"type":"function","title":"Options - A11yAudit.Assertions.assert_no_violations/2","doc":"- `:filter` - A module implementing the `A11yAudit.ViolationFilter` behavior that will be used to exclude violations matching the filter from the results. Defaults to `nil` (no excluded violations).\n- `:violations_print_limit` - The maximum number of violations that will be printed in the error when the assertion fails. Can be an integer or `:infinity`. Defaults to `:infinity`.\n- `:nodes_per_violation_print_limit` - The maximum number of nodes that will be printed for each violation when the assertion fails. Can be an integer or `:infinity`. Defaults to 5.\n- `:node_html_print_limit` - The maximum length of the HTML snippet that will be printed for each node when the assertion fails. Can be an integer or `:infinity`. Defaults to 100.","ref":"A11yAudit.Assertions.html#assert_no_violations/2-options"},{"type":"type","title":"A11yAudit.Assertions.opts/0","doc":"","ref":"A11yAudit.Assertions.html#t:opts/0"},{"type":"module","title":"A11yAudit.Hound","doc":"ExUnit assertions for Hound tests","ref":"A11yAudit.Hound.html"},{"type":"function","title":"A11yAudit.Hound.assert_no_violations/1","doc":"Runs an audit on the current page and asserts that the audit results have no violations.\n\nSee `A11yAudit.Assertions.assert_no_violations/2` for the list of configuration options.","ref":"A11yAudit.Hound.html#assert_no_violations/1"},{"type":"module","title":"A11yAudit.JS","doc":"axe-core JavaScript source","ref":"A11yAudit.JS.html"},{"type":"function","title":"A11yAudit.JS.await_audit_results/0","doc":"","ref":"A11yAudit.JS.html#await_audit_results/0"},{"type":"function","title":"A11yAudit.JS.axe_core/0","doc":"","ref":"A11yAudit.JS.html#axe_core/0"},{"type":"module","title":"A11yAudit.Results","doc":"Corresponds to axe-core's results object.\nSome fields omitted.\n\nAxe-core documentation: https://github.com/dequelabs/axe-core/blob/develop/doc/API.md#results-object","ref":"A11yAudit.Results.html"},{"type":"function","title":"A11yAudit.Results.from_json/1","doc":"","ref":"A11yAudit.Results.html#from_json/1"},{"type":"type","title":"A11yAudit.Results.t/0","doc":"","ref":"A11yAudit.Results.html#t:t/0"},{"type":"module","title":"A11yAudit.Results.Node","doc":"Corresponds to a single object in axe-core's nodes array of the violations array.\nSome fields omitted.\n\nAxe-core documentation: https://github.com/dequelabs/axe-core/blob/develop/doc/API.md#results-arrays","ref":"A11yAudit.Results.Node.html"},{"type":"type","title":"A11yAudit.Results.Node.t/0","doc":"","ref":"A11yAudit.Results.Node.html#t:t/0"},{"type":"module","title":"A11yAudit.Results.Violation","doc":"Corresponds to a single object in axe-core's violations array of the results object.\nSome fields omitted.\n\nAxe-core documentation: https://github.com/dequelabs/axe-core/blob/develop/doc/API.md#results-arrays","ref":"A11yAudit.Results.Violation.html"},{"type":"type","title":"A11yAudit.Results.Violation.impact/0","doc":"","ref":"A11yAudit.Results.Violation.html#t:impact/0"},{"type":"type","title":"A11yAudit.Results.Violation.t/0","doc":"","ref":"A11yAudit.Results.Violation.html#t:t/0"},{"type":"behaviour","title":"A11yAudit.ViolationFilter","doc":"A behavior for excluding certain violations from the results.\n\nModules implementing this behavior can be passed as a `:filter` option to:\n- `A11yAudit.Wallaby.assert_no_violations/2`\n- `A11yAudit.Hound.assert_no_violations/1`\n- `A11yAudit.Assertions.assert_no_violations/2`\n\nGenerally, it's not advisable to permanently exclude violations.\n\nIf one of the violations is a false-positive, submit a bug report with [axe-core](https://github.com/dequelabs/axe-core). If one of the violations is caused by a third-party library that you're using, submit a bug report with that library to help spread awareness about web accessibility.","ref":"A11yAudit.ViolationFilter.html"},{"type":"behaviour","title":"Example - A11yAudit.ViolationFilter","doc":"```\ndefmodule MyApp.A11yAuditViolationFilter do\n  @behaviour A11yAudit.ViolationFilter\n\n  @impl A11yAudit.ViolationFilter\n  def exclude_violation?(%A11yAudit.Results.Violation{} = violation) do\n    ids_to_ignore = [\"aria-deprecated-role\", \"image-redundant-alt\"]\n    violation.id in ids_to_ignore\n  end\nend\n```","ref":"A11yAudit.ViolationFilter.html#module-example"},{"type":"callback","title":"A11yAudit.ViolationFilter.exclude_violation?/1","doc":"","ref":"A11yAudit.ViolationFilter.html#c:exclude_violation?/1"},{"type":"module","title":"A11yAudit.Wallaby","doc":"ExUnit assertions for Wallaby tests","ref":"A11yAudit.Wallaby.html"},{"type":"function","title":"A11yAudit.Wallaby.assert_no_violations/2","doc":"Runs an audit on the current page and asserts that the audit results have no violations.\n\nSee `A11yAudit.Assertions.assert_no_violations/2` for the list of configuration options.","ref":"A11yAudit.Wallaby.html#assert_no_violations/2"},{"type":"extras","title":"A11yAudit","doc":"# A11yAudit\n\n![GitHub Workflow status](https://github.com/angelikatyborska/a11y-audit-elixir/actions/workflows/test.yml/badge.svg)\n![version on Hex.pm](https://img.shields.io/hexpm/v/a11y_audit)\n![number of downloads on Hex.pm](https://img.shields.io/hexpm/dt/a11y_audit)\n![license on Hex.pm](https://img.shields.io/hexpm/l/a11y_audit)\n\nAutomated accessibility testing for Elixir web applications using [axe-core](https://github.com/dequelabs/axe-core).\n\n![Expected page to have no accessibility violations, but got 1 violation. Form elements must have labels.](./docs/assets/cover.png)","ref":"readme.html"},{"type":"extras","title":"Installation - A11yAudit","doc":"The library can be installed by adding `a11y_audit` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:a11y_audit, \"~> 0.2.1\", only: :test}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - A11yAudit","doc":"A11yAudit provides assertions for browser-based tests.","ref":"readme.html#usage"},{"type":"extras","title":"For Wallaby - A11yAudit","doc":"Call `A11yAudit.Wallaby.assert_no_violations/1` in your [Wallaby](https://github.com/elixir-wallaby/wallaby) tests.\n\n```elixir\ndefmodule MyAppWeb.HomeTest do\n  use ExUnit.Case, async: true\n  use Wallaby.Feature\n\n  feature \"home page\", %{session: session} do\n    session\n    |> visit(\"/\")\n    |> assert_has(Query.css(\"h1\", text: \"My App\"))\n    |> A11yAudit.Wallaby.assert_no_violations()\n  end\nend\n```","ref":"readme.html#for-wallaby"},{"type":"extras","title":"For Hound - A11yAudit","doc":"Call `A11yAudit.Hound.assert_no_violations/0` in your [Hound](https://github.com/HashNuke/hound) tests.\n\n```elixir\ndefmodule MyAppWeb.HomeTest do\n  use ExUnit.Case\n  use Hound.Helpers\n\n  test \"home page\" do\n    navigate_to(\"#{MyAppWeb.Endpoint.url()}/\")\n\n    heading = find_element(:css, \"h1\")\n    assert inner_text(heading) == \"My App\"\n\n    A11yAudit.Hound.assert_no_violations()\n  end\nend\n```","ref":"readme.html#for-hound"},{"type":"extras","title":"For other environments - A11yAudit","doc":"If you're running browser-based tests in Elixir without using Wallaby or Hound, you can still use A11yAudit. You will need a way to execute JavaScript snippets, and to get their return values back into your Elixir code. Assuming you have an `execute_script` function that can do that, you can use the test assertions like so:\n\n```elixir\nget_audit_result =\n  fn ->\n    execute_script(A11yAudit.JS.axe_core())\n    axe_result_map = execute_script(A11yAudit.JS.await_audit_results())\n    A11yAudit.Results.from_json(axe_result_map)\n  end\n\nA11yAudit.Assertions.assert_no_violations(get_audit_result.())\n```","ref":"readme.html#for-other-environments"},{"type":"extras","title":"Configuration - A11yAudit","doc":"See the [documentation for `A11yAudit.Assertions.assert_no_violations/1`](https://hexdocs.pm/a11y_audit/A11yAudit.Assertions.html#assert_no_violations/2-options) for a full list of options.\n\nConfiguration options can be passed to the assertion functions (`A11yAudit.Wallaby.assert_no_violations/1`, `A11yAudit.Hound.assert_no_violations/0`, `A11yAudit.Assertions.assert_no_violations/1`).","ref":"readme.html#configuration"},{"type":"extras","title":"Supported browsers - A11yAudit","doc":"Please reference [axe-core's documentation](https://github.com/dequelabs/axe-core?tab=readme-ov-file#supported-browsers) to find out which browsers are supported.","ref":"readme.html#supported-browsers"},{"type":"extras","title":"Checks - A11yAudit","doc":"Please reference [axe-core's documentation](https://github.com/dequelabs/axe-core/blob/develop/doc/rule-descriptions.md) to find out which accessibility checks are run.","ref":"readme.html#checks"},{"type":"extras","title":"Caveats - A11yAudit","doc":"","ref":"readme.html#caveats"},{"type":"extras","title":"CSS transitions might cause flaky tests - A11yAudit","doc":"If the accessibility audit runs while a CSS transition is in progress, it might lead to intermittent failures of the [color contrast](https://dequeuniversity.com/rules/axe/3.5/color-contrast) check. To prevent this, I recommend [turning off CSS transitions in the test environment](https://angelika.me/2024/08/12/how-to-add-css-rules-only-in-test-env-phoenix-app/#what-to-do-instead).","ref":"readme.html#css-transitions-might-cause-flaky-tests"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"How does this project's versions match axe-core versions? - Changelog","doc":"Every time axe-core gets a major/minor/patch upgrade, this project also gets a major/minor/patch upgrade. But this project can also have upgrades unrelated to axe-core, which follow semantic versioning. As a result, this project's versions will not match axe-core versions exactly. Refer to [package-lock.json](./assets/package-lock.json) to learn the exact axe-core version currently used, or read the changelog.","ref":"changelog.html#how-does-this-project-s-versions-match-axe-core-versions"},{"type":"extras","title":"0.2.1 (2024-10-20) - Changelog","doc":"- Upgrade axe-core to 4.10.1.","ref":"changelog.html#0-2-1-2024-10-20"},{"type":"extras","title":"0.2.0 (2024-07-30) - Changelog","doc":"- Upgrade axe-core to 4.10.0.","ref":"changelog.html#0-2-0-2024-07-30"},{"type":"extras","title":"0.1.0 (2024-06-08) - Changelog","doc":"- Initial release, using axe-core 4.9.1.","ref":"changelog.html#0-1-0-2024-06-08"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}